//this is heavily based on kno33x Tecmo Bowl FAQ found on gamefaqs.com
//http://db.gamefaqs.com/console/nes/file/tecmo_bowl_b.txt
//it's incomplete; so original research was involved, too
//it would be better to have GUI here, but I'm too lazy...
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <math.h>

unsigned char Password[8];
char TeamName[4];
const char TeamList[12][4]={"IND","MIA","CLV","DNV","SEA","LAN","WAS","SNF","DAL","NWY","CHI","MIN"};
const char* Nobody="NOB";
const char* Random="RAN";
const unsigned int kno33xThirdChart[12]={0x8B8,0x8BA,0x8BD,0x8C2,0x8CB,0x8DC,0x8FD,0x93E,0x8CF,0x8E0,0x901,0x942};
unsigned int MyTeam;//index in that array
unsigned int NumofBeaten=0;
int EnemyTeam;
int* ListofDefeated;

void PasswordGenerator(void);
void VsRandomGenerator(unsigned int MyTeam, int *ListofDefeated);
void FirstWeekGenerator(unsigned int MyTeam,int EnemyTeam);
void VsParticularGenerator(unsigned int MyTeam,int EnemyTeam,int *ListofDefeated);

int main(int argc,char** argv)
{
	PasswordGenerator();
	printf("Press any key to quit.\n");
	getch();
	return 0;
}

void PasswordGenerator(void)
{
	char InputMyTeam[4];//one extra char needed b/c of fgets
    char InputEnemyTeam[4];
	char InputListofDefeated[11*4];//excluding one team, at least
	int i, k;
	int correct=0;
	printf("In this passgen all 12 teams are designated by three-character acronyms: \n");
	for(i=0;i<12;i++)
	printf("%s ",TeamList[i]);
	printf("\nEnter your team's name; you must use acronyms listed above: ");
	fgets(InputMyTeam,4,stdin);
	fflush(stdin);
	printf("Enter your opponent's name.\nYou can enter RAN to get a random opponent :");
	fgets(InputEnemyTeam,4,stdin);
	fflush(stdin);
	printf("Enter NOB to generate the 1st week password.\nEnter something else to specify one or more teams you've already beaten: ");
	ListofDefeated=(unsigned int*)malloc(sizeof(int));
	fgets(InputListofDefeated,4,stdin);
	fflush(stdin);
	if(!stricmp(InputListofDefeated,Nobody))
		*ListofDefeated=-1;
	else
	{
		printf("\nEnter one or several teams you've beaten.\nPress Enter key after each team you print.\nEnter END to terminate input:\n");
		for(i=0;i<11;i++)
		{
			fgets(InputListofDefeated+4*i,4,stdin);
			fflush(stdin);
			if(!stricmp(InputListofDefeated+4*i,"END"))
			break;
		}
		realloc(ListofDefeated,i*sizeof(int));
		*ListofDefeated=0;
		NumofBeaten=i;
		//printf("%d \n",NumofBeaten);//debug stuff
		if(NumofBeaten==0)
			*ListofDefeated=-1;
	}//endelse
	for(i=0;i<12;i++)//check #1
	{
		if (!stricmp(InputMyTeam,TeamList[i]))
		{
			MyTeam=i;
			correct=1;
		}
	};
	if(!correct)
	{
		printf("You entered a wrong name of your own team.\n");
		return;
	}
	correct=0;
	for(i=0;i<12;i++)//check #2
	{
		if (!stricmp(InputEnemyTeam,TeamList[i]))
		{
			EnemyTeam=i;
			correct=1;
		}
	};
	if(!stricmp(InputEnemyTeam,Random))
	{
        EnemyTeam=-1;
		correct=1;
	}
	if(!correct)
	{
		printf("You entered a wrong name of your opponent's team.\n");
		return;
	}
	correct=0;
	if(*ListofDefeated==0)//check #3, tested
	{
        for(i=0;i<NumofBeaten;i++)
		{
			for(k=0;k<12;k++)
			{
				if (!stricmp(InputListofDefeated+i*4,TeamList[k]))
				{
					ListofDefeated[i]=k;
					correct=1;
				}
			}
			if(!correct)
			{
				printf("%s%s\n","You entered a wrong name of a beaten team: ",InputListofDefeated+i*4);
				return;
			}
			correct=0;
		};
	}//endif
	for(i=0;i<NumofBeaten;i++)//check #4, tested
	{
		if(MyTeam==ListofDefeated[i])
		{
			printf("You couldn't have beaten yourself.\n");
			return;
		}
	}
	for(i=0;i<NumofBeaten;i++)//check#5, tested 
	{
		for(k=0;k<NumofBeaten;k++)
		{
			if((i!=k)&&(ListofDefeated[i]==ListofDefeated[k]))
			{
				printf("%s%s%s","You couln't have beaten ",InputListofDefeated+i*4," twice.\n");
				return;
			}
		}
	}
	if(EnemyTeam>=0)//check#6, tested
	{
		for(i=0;i<NumofBeaten;i++)
		{
			if(EnemyTeam==ListofDefeated[i])
			{
				printf("You can't fight a team you've already beaten.\n");
				return;
			}
		}
	}
	if((EnemyTeam==-1)&&(*ListofDefeated==-1))//check#7
	{
		printf("You can't generate a password for the very beginning of the game.\n");
		return;
	}
	if(MyTeam==EnemyTeam)//check#8
	{
		if(NumofBeaten==11)
			printf("Theoretically you can fight yourself in the final.\nThere're passwords for this (like 01AFFEA6),\nbut I excluded this opportunity.\n");
		else
			printf("You can't fight yourself before the final.");
		return;
	}
	if((EnemyTeam>=0)&&(*ListofDefeated>=0))
		VsParticularGenerator(MyTeam,EnemyTeam,ListofDefeated);
	if(EnemyTeam==-1)
		VsRandomGenerator(MyTeam,ListofDefeated);
	if(*ListofDefeated==-1)
		FirstWeekGenerator(MyTeam,EnemyTeam);
	free(ListofDefeated);
	return;
}

void VsRandomGenerator(unsigned int MyTeam, int* ListofDefeated)
{
	int i, j;
	int TopmostDefeated=13;
	unsigned int BaseNum;
	for(i=0;i<NumofBeaten;i++)
	{
		if (ListofDefeated[i]<TopmostDefeated)
			TopmostDefeated=ListofDefeated[i];
	}
	i=MyTeam*4+(TopmostDefeated%4)+(0x40*((int)TopmostDefeated/4));
	Password[0]=i/16;
	Password[1]=i%16;
	i=pow(2,MyTeam);
	for (j=0;j<NumofBeaten;j++)
		i+=pow(2,ListofDefeated[j]);
	Password[3]=i/256;
	Password[4]=(i%256)/16;
	Password[5]=i%16;
	BaseNum=kno33xThirdChart[TopmostDefeated];//we regrouped that 3rd chart to its genuine n2n1n3 presentation to simplify math
	BaseNum+=MyTeam;//now we got the basic number from the 3rd chart (already regrouped)
	//printf("%X\n",BaseNum);//debug stuff
	if(MyTeam<4)
		BaseNum+=pow(2,MyTeam);
	else
		BaseNum+=pow(2,MyTeam%4)*16;//no danger of overflow here
	for(i=0;i<NumofBeaten;i++)
	{
		if (ListofDefeated[i]!=TopmostDefeated)
		{
			if(ListofDefeated[i]<4)
				BaseNum+=pow(2,ListofDefeated[i]);
			else
				BaseNum+=pow(2,ListofDefeated[i]%4)*16;
		}
	}
	if(BaseNum>=4096)//I think it's impossible
	{
		printf("Program error.\n");
		getch();
		exit(0);
	}
	Password[6]=BaseNum/256;
	Password[2]=(BaseNum%256)/16;
	Password[7]=BaseNum%16;
	printf("Your password has been generated: \n");
	for(i=0;i<8;i++)
		printf("%X",Password[i]);
	printf("\n");
}

void FirstWeekGenerator(unsigned int MyTeam,int EnemyTeam)
{//yep, always 8 passes, checked
	int i,j,k;
	unsigned int BaseNum;
	unsigned int Group345;
	i=MyTeam*4+(EnemyTeam%4)+(0x40*(EnemyTeam/4));
	Password[0]=i/16;
	Password[1]=i%16;
	Group345=pow(2,EnemyTeam);
	j=Group345;
	BaseNum=kno33xThirdChart[EnemyTeam];
	BaseNum=(BaseNum+MyTeam+0x780)%4096;//now we got the basic number from the 3rd chart
	//printf("%X\n",BaseNum);//debug stuff
	k=BaseNum;
	printf("Your 8 passwords for the 1st week have been generated: \n");
	for(i=0;i<8;i++)//the game itself only gives passes with i=MyTeam
	{
			j+=pow(2,i);
			Password[3]=j/256;
			Password[4]=(j%256)/16;
			Password[5]=j%16;
			k+=pow(2,i);
			Password[6]=k/256;
			Password[2]=(k%256)/16;
			Password[7]=k%16;
			for(j=0;j<8;j++)
			printf("%X",Password[j]);
			printf("\n");
			j=Group345;//restore these values;not to increase them again and again
			k=BaseNum;
	}
}

void VsParticularGenerator(unsigned int MyTeam,int EnemyTeam,int *ListofDefeated)
{//works
	int i, j;
	unsigned int BaseNum;
	i=MyTeam*4+(EnemyTeam%4)+(0x40*(EnemyTeam/4));
	Password[0]=i/16;
	Password[1]=i%16;
	i=pow(2,EnemyTeam)+pow(2,MyTeam);
	for(j=0;j<NumofBeaten;j++)
		i+=pow(2,ListofDefeated[j]);
	Password[3]=i/256;
	Password[4]=(i%256)/16;
	Password[5]=i%16;
	BaseNum=kno33xThirdChart[EnemyTeam];
	BaseNum=(BaseNum+MyTeam+0x780)%4096;//now we got the basic number from the 3rd chart
	//printf("%X\n",BaseNum);//debug stuff
	if (MyTeam<8)
		BaseNum+=pow(2,MyTeam);
	else
		BaseNum+=pow(2,MyTeam-4);//checked
	for (i=0;i<NumofBeaten;i++)
	{
		if(ListofDefeated[i]<8)
			BaseNum+=pow(2,ListofDefeated[i]);
		else
			BaseNum+=pow(2,ListofDefeated[i]-4);//checked
	}
	Password[6]=BaseNum/256;
	Password[2]=(BaseNum%256)/16;
	Password[7]=BaseNum%16;
	printf("Your password has been generated: \n");
	for(j=0;j<8;j++)
		printf("%X",Password[j]);
	printf("\n");
}